added ipv6 transport mode scenarios for IKEv1 and IKEv2
authorAndreas Steffen <andreas.steffen@strongswan.org>
Wed, 19 Dec 2007 00:45:26 +0000 (00:45 -0000)
committerAndreas Steffen <andreas.steffen@strongswan.org>
Wed, 19 Dec 2007 00:45:26 +0000 (00:45 -0000)
26 files changed:
testing/tests/ipv6/host2host-ikev1/hosts/moon/etc/ipsec.conf
testing/tests/ipv6/host2host-ikev1/hosts/sun/etc/ipsec.conf
testing/tests/ipv6/net2net-ikev1/hosts/moon/etc/ipsec.conf
testing/tests/ipv6/net2net-ikev1/hosts/sun/etc/ipsec.conf
testing/tests/ipv6/rw-ikev1/hosts/carol/etc/ipsec.conf
testing/tests/ipv6/rw-ikev1/hosts/moon/etc/ipsec.conf
testing/tests/ipv6/rw-psk-ikev1/hosts/carol/etc/ipsec.conf
testing/tests/ipv6/rw-psk-ikev1/hosts/moon/etc/ipsec.conf
testing/tests/ipv6/transport-ikev1/description.txt [new file with mode: 0644]
testing/tests/ipv6/transport-ikev1/evaltest.dat [new file with mode: 0644]
testing/tests/ipv6/transport-ikev1/hosts/moon/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/transport-ikev1/hosts/moon/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ipv6/transport-ikev1/hosts/sun/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/transport-ikev1/hosts/sun/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ipv6/transport-ikev1/posttest.dat [new file with mode: 0644]
testing/tests/ipv6/transport-ikev1/pretest.dat [new file with mode: 0644]
testing/tests/ipv6/transport-ikev1/test.conf [new file with mode: 0644]
testing/tests/ipv6/transport-ikev2/description.txt [new file with mode: 0644]
testing/tests/ipv6/transport-ikev2/evaltest.dat [new file with mode: 0644]
testing/tests/ipv6/transport-ikev2/hosts/moon/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/transport-ikev2/hosts/moon/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ipv6/transport-ikev2/hosts/sun/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/transport-ikev2/hosts/sun/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ipv6/transport-ikev2/posttest.dat [new file with mode: 0644]
testing/tests/ipv6/transport-ikev2/pretest.dat [new file with mode: 0644]
testing/tests/ipv6/transport-ikev2/test.conf [new file with mode: 0644]

index 5a18c09..2814e88 100755 (executable)
@@ -19,11 +19,9 @@ conn net-net
 
 conn host-host
        left=PH_IP6_MOON
-       leftnexthop=0::0
        leftcert=moonCert.pem
        leftid=@moon.strongswan.org
        leftfirewall=yes
        right=PH_IP6_SUN
-       rightnexthop=0::0
        rightid=@sun.strongswan.org
        auto=add
index c64904a..4cf027a 100755 (executable)
@@ -19,11 +19,9 @@ conn net-net
 
 conn host-host
        left=PH_IP6_SUN
-       leftnexthop=0::0
        leftcert=sunCert.pem
        leftid=@sun.strongswan.org
        leftfirewall=yes
        right=PH_IP6_MOON
-       rightnexthop=0::0
        rightid=@moon.strongswan.org
        auto=add
index 9499140..84abbb0 100755 (executable)
@@ -19,12 +19,10 @@ conn net-net
 
 conn host-host
        left=PH_IP6_MOON
-       leftnexthop=0::0
        leftcert=moonCert.pem
        leftid=@moon.strongswan.org
        leftfirewall=yes
        right=PH_IP6_SUN
-       rightnexthop=0::0
        rightid=@sun.strongswan.org
        auto=add
 
index c64904a..4cf027a 100755 (executable)
@@ -19,11 +19,9 @@ conn net-net
 
 conn host-host
        left=PH_IP6_SUN
-       leftnexthop=0::0
        leftcert=sunCert.pem
        leftid=@sun.strongswan.org
        leftfirewall=yes
        right=PH_IP6_MOON
-       rightnexthop=0::0
        rightid=@moon.strongswan.org
        auto=add
index 753d71c..b276099 100755 (executable)
@@ -14,12 +14,10 @@ conn %default
 
 conn home
        left=PH_IP6_CAROL
-       leftnexthop=0::0
        leftcert=carolCert.pem
        leftid=carol@strongswan.org
        leftfirewall=yes
        right=PH_IP6_MOON
-       rightnexthop=0::0
        rightsubnet=fec1::/16
        rightid=@moon.strongswan.org
        auto=add
index 520b538..0129ef7 100755 (executable)
@@ -14,11 +14,9 @@ conn %default
 
 conn rw
        left=PH_IP6_MOON
-       leftnexthop=0::0
        leftcert=moonCert.pem
        leftid=@moon.strongswan.org
        leftsubnet=fec1::/16
        leftfirewall=yes
-       right=%any
-       rightnexthop=0::0
+       right=%any6
        auto=add
index 8c8624b..5d77c2d 100755 (executable)
@@ -13,9 +13,7 @@ conn %default
        
 conn home
        left=PH_IP6_CAROL
-       leftnexthop=0::0
        leftfirewall=yes
        right=PH_IP6_MOON
-       rightnexthop=0::0
        rightsubnet=fec1::/16
        auto=add
index 1387a5b..78f6740 100755 (executable)
@@ -14,8 +14,6 @@ conn %default
 conn rw
        left=PH_IP6_MOON
        leftsubnet=fec1::/16
-       leftnexthop=0::0
        leftfirewall=yes
-       right=%any
-       rightnexthop=0::0
+       right=%any6
        auto=add
diff --git a/testing/tests/ipv6/transport-ikev1/description.txt b/testing/tests/ipv6/transport-ikev1/description.txt
new file mode 100644 (file)
index 0000000..2d54790
--- /dev/null
@@ -0,0 +1,5 @@
+An IPv6 ESP transport connection between the hosts <b>moon</b> and <b>sun</b> is successfully set up.
+The authentication is based on X.509 certificates. Upon the successful establishment of
+the IPsec SA, <b>leftfirewall=yes</b> automatically inserts ip6tables-based firewall
+rules that let pass the protected traffic. In order to test both the transport connection
+and the firewall rules, <b>moon</b> sends an IPv6 ICMP request to <b>sun</b> using the ping6 command.
diff --git a/testing/tests/ipv6/transport-ikev1/evaltest.dat b/testing/tests/ipv6/transport-ikev1/evaltest.dat
new file mode 100644 (file)
index 0000000..62fc859
--- /dev/null
@@ -0,0 +1,5 @@
+moon::ipsec status::host-host.*STATE_QUICK_I2.*IPsec SA established::YES
+sun::ipsec status::host-host.*STATE_QUICK_R2.*IPsec SA established::YES
+moon::ping6 -c 1 -p deadbeef ip6-sun.strongswan.org::64 bytes from ip6-sun.strongswan.org: icmp_seq=1::YES
+sun::tcpdump::IP6 ip6-moon.strongswan.org > ip6-sun.strongswan.org: ESP::YES
+sun::tcpdump::IP6 ip6-sun.strongswan.org > ip6-moon.strongswan.org: ESP::YES
diff --git a/testing/tests/ipv6/transport-ikev1/hosts/moon/etc/init.d/iptables b/testing/tests/ipv6/transport-ikev1/hosts/moon/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..521d1ce
--- /dev/null
@@ -0,0 +1,100 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/iptables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
diff --git a/testing/tests/ipv6/transport-ikev1/hosts/moon/etc/ipsec.conf b/testing/tests/ipv6/transport-ikev1/hosts/moon/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..8bc0deb
--- /dev/null
@@ -0,0 +1,23 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+       plutodebug=control
+       crlcheckinterval=180
+       strictcrlpolicy=no
+       charonstart=no
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+
+conn host-host
+       left=PH_IP6_MOON
+       leftcert=moonCert.pem
+       leftid=@moon.strongswan.org
+       leftfirewall=yes
+       right=PH_IP6_SUN
+       rightid=@sun.strongswan.org
+       type=transport
+       auto=add
diff --git a/testing/tests/ipv6/transport-ikev1/hosts/sun/etc/init.d/iptables b/testing/tests/ipv6/transport-ikev1/hosts/sun/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..521d1ce
--- /dev/null
@@ -0,0 +1,100 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/iptables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
diff --git a/testing/tests/ipv6/transport-ikev1/hosts/sun/etc/ipsec.conf b/testing/tests/ipv6/transport-ikev1/hosts/sun/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..b68082d
--- /dev/null
@@ -0,0 +1,23 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+       plutodebug=control
+       crlcheckinterval=180
+       strictcrlpolicy=no
+       charonstart=no
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+
+conn host-host
+       left=PH_IP6_SUN
+       leftcert=sunCert.pem
+       leftid=@sun.strongswan.org
+       leftfirewall=yes
+       right=PH_IP6_MOON
+       rightid=@moon.strongswan.org
+       type=transport
+       auto=add
diff --git a/testing/tests/ipv6/transport-ikev1/posttest.dat b/testing/tests/ipv6/transport-ikev1/posttest.dat
new file mode 100644 (file)
index 0000000..5a9150b
--- /dev/null
@@ -0,0 +1,4 @@
+moon::ipsec stop
+sun::ipsec stop
+moon::/etc/init.d/iptables stop 2> /dev/null
+sun::/etc/init.d/iptables stop 2> /dev/null
diff --git a/testing/tests/ipv6/transport-ikev1/pretest.dat b/testing/tests/ipv6/transport-ikev1/pretest.dat
new file mode 100644 (file)
index 0000000..3536fd8
--- /dev/null
@@ -0,0 +1,6 @@
+moon::/etc/init.d/iptables start 2> /dev/null
+sun::/etc/init.d/iptables start 2> /dev/null
+moon::ipsec start
+sun::ipsec start
+moon::sleep 2 
+moon::ipsec up host-host
diff --git a/testing/tests/ipv6/transport-ikev1/test.conf b/testing/tests/ipv6/transport-ikev1/test.conf
new file mode 100644 (file)
index 0000000..6ab5b8a
--- /dev/null
@@ -0,0 +1,21 @@
+#!/bin/bash
+#
+# This configuration file provides information on the
+# UML instances used for this test
+
+# All UML instances that are required for this test
+#
+UMLHOSTS="moon winnetou sun"
+# Corresponding block diagram
+#
+DIAGRAM="m-w-s-ip6.png"
+
+# UML instances on which tcpdump is to be started
+#
+TCPDUMPHOSTS="sun"
+
+# UML instances on which IPsec is started
+# Used for IPsec logging purposes
+#
+IPSECHOSTS="moon sun"
diff --git a/testing/tests/ipv6/transport-ikev2/description.txt b/testing/tests/ipv6/transport-ikev2/description.txt
new file mode 100644 (file)
index 0000000..2d54790
--- /dev/null
@@ -0,0 +1,5 @@
+An IPv6 ESP transport connection between the hosts <b>moon</b> and <b>sun</b> is successfully set up.
+The authentication is based on X.509 certificates. Upon the successful establishment of
+the IPsec SA, <b>leftfirewall=yes</b> automatically inserts ip6tables-based firewall
+rules that let pass the protected traffic. In order to test both the transport connection
+and the firewall rules, <b>moon</b> sends an IPv6 ICMP request to <b>sun</b> using the ping6 command.
diff --git a/testing/tests/ipv6/transport-ikev2/evaltest.dat b/testing/tests/ipv6/transport-ikev2/evaltest.dat
new file mode 100644 (file)
index 0000000..1ea5bce
--- /dev/null
@@ -0,0 +1,8 @@
+moon::cat /var/log/daemon.log::received USE_TRANSPORT_MODE notify::YES
+moon::ipsec status::host-host.*INSTALLED.*TRANSPORT::YES
+sun::ipsec status::host-host.*INSTALLED.*TRANSPORT::YES
+moon::ip xfrm state::mode transport::YES
+sun::ip xfrm state::mode transport::YES
+moon::ping6 -c 1 -p deadbeef ip6-sun.strongswan.org::64 bytes from ip6-sun.strongswan.org: icmp_seq=1::YES
+sun::tcpdump::IP6 ip6-moon.strongswan.org > ip6-sun.strongswan.org: ESP::YES
+sun::tcpdump::IP6 ip6-sun.strongswan.org > ip6-moon.strongswan.org: ESP::YES
diff --git a/testing/tests/ipv6/transport-ikev2/hosts/moon/etc/init.d/iptables b/testing/tests/ipv6/transport-ikev2/hosts/moon/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..25074a0
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/iptables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
diff --git a/testing/tests/ipv6/transport-ikev2/hosts/moon/etc/ipsec.conf b/testing/tests/ipv6/transport-ikev2/hosts/moon/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..7df72bd
--- /dev/null
@@ -0,0 +1,24 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+       strictcrlpolicy=no
+       crlcheckinterval=180
+       plutostart=no
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+       mobike=no
+       keyexchange=ikev2
+
+conn host-host
+       left=PH_IP6_MOON
+       leftcert=moonCert.pem
+       leftid=@moon.strongswan.org
+       leftfirewall=yes
+       right=PH_IP6_SUN
+       rightid=@sun.strongswan.org
+       type=transport
+       auto=add
diff --git a/testing/tests/ipv6/transport-ikev2/hosts/sun/etc/init.d/iptables b/testing/tests/ipv6/transport-ikev2/hosts/sun/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..25074a0
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/iptables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
diff --git a/testing/tests/ipv6/transport-ikev2/hosts/sun/etc/ipsec.conf b/testing/tests/ipv6/transport-ikev2/hosts/sun/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..b306ec6
--- /dev/null
@@ -0,0 +1,24 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+       strictcrlpolicy=no
+       crlcheckinterval=180
+       plutostart=no
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+       mobike=no
+       keyexchange=ikev2
+
+conn host-host
+       left=PH_IP6_SUN
+       leftcert=sunCert.pem
+       leftid=@sun.strongswan.org
+       leftfirewall=yes
+       right=PH_IP6_MOON
+       rightid=@moon.strongswan.org
+       type=transport
+       auto=add
diff --git a/testing/tests/ipv6/transport-ikev2/posttest.dat b/testing/tests/ipv6/transport-ikev2/posttest.dat
new file mode 100644 (file)
index 0000000..5a9150b
--- /dev/null
@@ -0,0 +1,4 @@
+moon::ipsec stop
+sun::ipsec stop
+moon::/etc/init.d/iptables stop 2> /dev/null
+sun::/etc/init.d/iptables stop 2> /dev/null
diff --git a/testing/tests/ipv6/transport-ikev2/pretest.dat b/testing/tests/ipv6/transport-ikev2/pretest.dat
new file mode 100644 (file)
index 0000000..3536fd8
--- /dev/null
@@ -0,0 +1,6 @@
+moon::/etc/init.d/iptables start 2> /dev/null
+sun::/etc/init.d/iptables start 2> /dev/null
+moon::ipsec start
+sun::ipsec start
+moon::sleep 2 
+moon::ipsec up host-host
diff --git a/testing/tests/ipv6/transport-ikev2/test.conf b/testing/tests/ipv6/transport-ikev2/test.conf
new file mode 100644 (file)
index 0000000..6ab5b8a
--- /dev/null
@@ -0,0 +1,21 @@
+#!/bin/bash
+#
+# This configuration file provides information on the
+# UML instances used for this test
+
+# All UML instances that are required for this test
+#
+UMLHOSTS="moon winnetou sun"
+# Corresponding block diagram
+#
+DIAGRAM="m-w-s-ip6.png"
+
+# UML instances on which tcpdump is to be started
+#
+TCPDUMPHOSTS="sun"
+
+# UML instances on which IPsec is started
+# Used for IPsec logging purposes
+#
+IPSECHOSTS="moon sun"